## crystal 1.9.2+dfsg

=== Makefile ===
all:

-include Makefile.local # for optional local options e.g. threads

# Recipes for this Makefile

## Build the compiler
##   $ make
## Build the compiler with progress output
##   $ make progress=1
## Clean up built files then build the compiler
##   $ make clean crystal
## Build the compiler in release mode
##   $ make crystal release=1 interpreter=1
## Run tests
##   $ make test
## Run stdlib tests
##   $ make std_spec
## Run compiler tests
##   $ make compiler_spec

CRYSTAL ?= crystal ## which previous crystal compiler use
LLVM_CONFIG ?=     ## llvm-config command path to use

release ?=      ## Compile in release mode
stats ?=        ## Enable statistics output
progress ?=     ## Enable progress output
threads ?=      ## Maximum number of threads to use
debug ?=        ## Add symbolic debug info
verbose ?=      ## Run specs in verbose mode
junit_output ?= ## Path to output junit results
static ?=       ## Enable static linking
target ?=       ## Cross-compilation target
interpreter ?=  ## Enable interpreter feature
check ?=        ## Enable only check when running format
order ?=random  ## Enable order for spec execution (values: "default" | "random" | seed number)

O := .build
SOURCES := $(shell find src -name '*.cr')
SPEC_SOURCES := $(shell find spec -name '*.cr')
override FLAGS += -D strict_multi_assign -D preview_overload_order $(if $(release),--release )$(if $(stats),--stats )$(if $(progress),--progress )$(if $(threads),--threads $(threads) )$(if $(debug),-d )$(if $(static),--static )$(if $(LDFLAGS),--link-flags="$(LDFLAGS)" )$(if $(target),--cross-compile --target $(target) )$(if $(interpreter),,-Dwithout_interpreter )
SPEC_WARNINGS_OFF := --exclude-warnings spec/std --exclude-warnings spec/compiler --exclude-warnings spec/primitives
SPEC_FLAGS := $(if $(verbose),-v )$(if $(junit_output),--junit_output $(junit_output) )$(if $(order),--order=$(order) )
CRYSTAL_CONFIG_LIBRARY_PATH := '$$ORIGIN/../lib/crystal'
CRYSTAL_CONFIG_BUILD_COMMIT ?= $(shell git rev-parse --short HEAD 2> /dev/null)
CRYSTAL_CONFIG_PATH := '$$ORIGIN/../share/crystal/src'
SOURCE_DATE_EPOCH ?= $(shell (git show -s --format=%ct HEAD || stat -c "%Y" Makefile || stat -f "%m" Makefile) 2> /dev/null)
ifeq ($(shell command -v ld.lld >/dev/null && uname -s),Linux)
  EXPORT_CC ?= CC="$(CC) -fuse-ld=lld"
endif
EXPORTS := \
  CRYSTAL_CONFIG_BUILD_COMMIT="$(CRYSTAL_CONFIG_BUILD_COMMIT)" \
	CRYSTAL_CONFIG_PATH=$(CRYSTAL_CONFIG_PATH) \
	SOURCE_DATE_EPOCH="$(SOURCE_DATE_EPOCH)"
EXPORTS_BUILD := \
	$(EXPORT_CC) \
	CRYSTAL_CONFIG_LIBRARY_PATH=$(CRYSTAL_CONFIG_LIBRARY_PATH)
SHELL = sh
LLVM_CONFIG := $(shell src/llvm/ext/find-llvm-config)
LLVM_VERSION := $(if $(LLVM_CONFIG), $(shell $(LLVM_CONFIG) --version 2> /dev/null))
LLVM_EXT_DIR = src/llvm/ext
LLVM_EXT_OBJ = $(LLVM_EXT_DIR)/llvm_ext.o
DEPS = $(LLVM_EXT_OBJ)
CXXFLAGS += $(if $(debug),-g -O0)
CRYSTAL_VERSION ?= $(shell cat src/VERSION)

DESTDIR ?=
PREFIX ?= /usr/local
BINDIR ?= $(DESTDIR)$(PREFIX)/bin
MANDIR ?= $(DESTDIR)$(PREFIX)/share/man
LIBDIR ?= $(DESTDIR)$(PREFIX)/lib
DATADIR ?= $(DESTDIR)$(PREFIX)/share/crystal
INSTALL ?= /usr/bin/install

ifeq ($(or $(TERM),$(TERM),dumb),dumb)
  colorize = $(shell printf >&2 "$1")
else
  colorize = $(shell printf >&2 "\033[33m$1\033[0m\n")
endif

check_llvm_config = $(eval \
	check_llvm_config := $(if $(LLVM_VERSION),\
	  $(call colorize,Using $(LLVM_CONFIG) [version=$(LLVM_VERSION)]),\
	  $(error "Could not locate compatible llvm-config, make sure it is installed and in your PATH, or set LLVM_CONFIG. Compatible versions: $(shell cat src/llvm/ext/llvm-versions.txt)))\
	)

.PHONY: all
all: crystal ## Build all files (currently crystal only) [default]

.PHONY: test
test: spec ## Run tests

.PHONY: spec
spec: std_spec primitives_spec compiler_spec

.PHONY: std_spec
std_spec: $(O)/std_spec ## Run standard library specs
	$(O)/std_spec $(SPEC_FLAGS)

.PHONY: compiler_spec
compiler_spec: $(O)/compiler_spec ## Run compiler specs
	$(O)/compiler_spec $(SPEC_FLAGS)

.PHONY: primitives_spec
primitives_spec: $(O)/primitives_spec ## Run primitives specs
	$(O)/primitives_spec $(SPEC_FLAGS)

.PHONY: interpreter_spec
interpreter_spec: $(O)/interpreter_spec ## Run interpreter specs
	$(O)/interpreter_spec $(SPEC_FLAGS)

.PHONY: smoke_test
smoke_test: ## Build specs as a smoke test
smoke_test: $(O)/std_spec $(O)/compiler_spec $(O)/crystal

.PHONY: all_spec
all_spec: $(O)/all_spec ## Run all specs (note: this builds a huge program; `test` recipe builds individual binaries and is recommended for reduced resource usage)
	$(O)/all_spec $(SPEC_FLAGS)

.PHONY: samples
samples: ## Build example programs
	$(MAKE) -C samples

.PHONY: docs
docs: ## Generate standard library documentation
	$(call check_llvm_config)
	./bin/crystal docs src/docs_main.cr $(DOCS_OPTIONS) --project-name=Crystal --project-version=$(CRYSTAL_VERSION) --source-refname=$(CRYSTAL_CONFIG_BUILD_COMMIT)

.PHONY: crystal
crystal: $(O)/crystal ## Build the compiler

.PHONY: deps llvm_ext
deps: $(DEPS) ## Build dependencies
llvm_ext: $(LLVM_EXT_OBJ)

.PHONY: format
format: ## Format sources
	./bin/crystal tool format$(if $(check), --check) src spec samples scripts

.PHONY: install
install: $(O)/crystal man/crystal.1.gz ## Install the compiler at DESTDIR
	$(INSTALL) -d -m 0755 "$(BINDIR)/"
	$(INSTALL) -m 0755 "$(O)/crystal" "$(BINDIR)/crystal"

	$(INSTALL) -d -m 0755 $(DATADIR)
	cp -av src "$(DATADIR)/src"
	rm -rf "$(DATADIR)/$(LLVM_EXT_OBJ)" # Don't install llvm_ext.o

	$(INSTALL) -d -m 0755 "$(MANDIR)/man1/"
	$(INSTALL) -m 644 man/crystal.1.gz "$(MANDIR)/man1/crystal.1.gz"
	$(INSTALL) -d -m 0755 "$(DESTDIR)$(PREFIX)/share/licenses/crystal/"
	$(INSTALL) -m 644 LICENSE "$(DESTDIR)$(PREFIX)/share/licenses/crystal/LICENSE"

	$(INSTALL) -d -m 0755 "$(DESTDIR)$(PREFIX)/share/bash-completion/completions/"
	$(INSTALL) -m 644 etc/completion.bash "$(DESTDIR)$(PREFIX)/share/bash-completion/completions/crystal"
	$(INSTALL) -d -m 0755 "$(DESTDIR)$(PREFIX)/share/zsh/site-functions/"
	$(INSTALL) -m 644 etc/completion.zsh "$(DESTDIR)$(PREFIX)/share/zsh/site-functions/_crystal"
	$(INSTALL) -d -m 0755 "$(DESTDIR)$(PREFIX)/share/fish/vendor_completions.d/"
	$(INSTALL) -m 644 etc/completion.fish "$(DESTDIR)$(PREFIX)/share/fish/vendor_completions.d/crystal.fish"

.PHONY: uninstall
uninstall: ## Uninstall the compiler from DESTDIR
	rm -f "$(BINDIR)/crystal"

	rm -rf "$(DATADIR)/src"

	rm -f "$(MANDIR)/man1/crystal.1.gz"
	rm -f "$(DESTDIR)$(PREFIX)/share/licenses/crystal/LICENSE"

	rm -f "$(DESTDIR)$(PREFIX)/share/bash-completion/completions/crystal"
	rm -f "$(DESTDIR)$(PREFIX)/share/zsh/site-functions/_crystal"

.PHONY: install_docs
install_docs: docs ## Install docs at DESTDIR
	$(INSTALL) -d -m 0755 $(DATADIR)

	cp -av docs "$(DATADIR)/docs"
	cp -av samples "$(DATADIR)/examples"
	rm -rf "$(DATADIR)/examples/.gitignore"

.PHONY: uninstall_docs
uninstall_docs: ## Uninstall docs from DESTDIR
	rm -rf "$(DATADIR)/docs"
	rm -rf "$(DATADIR)/examples"

$(O)/all_spec: $(DEPS) $(SOURCES) $(SPEC_SOURCES)
	$(call check_llvm_config)
	@mkdir -p $(O)
	$(EXPORT_CC) $(EXPORTS) ./bin/crystal build $(FLAGS) $(SPEC_WARNINGS_OFF) -o $@ spec/all_spec.cr

$(O)/std_spec: $(DEPS) $(SOURCES) $(SPEC_SOURCES)
	$(call check_llvm_config)
	@mkdir -p $(O)
	$(EXPORT_CC) ./bin/crystal build $(FLAGS) $(SPEC_WARNINGS_OFF) -o $@ spec/std_spec.cr

$(O)/compiler_spec: $(DEPS) $(SOURCES) $(SPEC_SOURCES)
	$(call check_llvm_config)
	@mkdir -p $(O)
	$(EXPORT_CC) $(EXPORTS) ./bin/crystal build $(FLAGS) $(SPEC_WARNINGS_OFF) -o $@ spec/compiler_spec.cr --release

$(O)/primitives_spec: $(O)/crystal $(DEPS) $(SOURCES) $(SPEC_SOURCES)
	@mkdir -p $(O)
	$(EXPORT_CC) ./bin/crystal build $(FLAGS) $(SPEC_WARNINGS_OFF) -o $@ spec/primitives_spec.cr

$(O)/interpreter_spec: deps $(SOURCES) $(SPEC_SOURCES)
	$(eval interpreter=1)
	@mkdir -p $(O)
	$(EXPORT_CC) ./bin/crystal build $(FLAGS) $(SPEC_WARNINGS_OFF) -o $@ spec/compiler/interpreter_spec.cr

$(O)/crystal: $(DEPS) $(SOURCES)
	$(call check_llvm_config)
	@mkdir -p $(O)
	@# NOTE: USE_PCRE1 is only used for testing compatibility with legacy environments that don't provide libpcre2.
	@# Newly built compilers should never be distributed with libpcre to ensure syntax consistency.
	$(EXPORTS) $(EXPORTS_BUILD) ./bin/crystal build $(FLAGS) -o $@ src/compiler/crystal.cr -D without_openssl -D without_zlib $(if $(USE_PCRE1),-D use_pcre,-D use_pcre2)

$(LLVM_EXT_OBJ): $(LLVM_EXT_DIR)/llvm_ext.cc
	$(call check_llvm_config)
	$(CXX) -c $(CXXFLAGS) -o $@ $< $(shell $(LLVM_CONFIG) --cxxflags)

man/%.gz: man/%
	gzip -c -9 $< > $@

.PHONY: clean
clean: clean_crystal ## Clean up built directories and files
	rm -rf $(LLVM_EXT_OBJ)

.PHONY: clean_crystal
clean_crystal: ## Clean up crystal built files
	rm -rf $(O)
	rm -rf ./docs

.PHONY: clean_cache
clean_cache: ## Clean up CRYSTAL_CACHE_DIR files
	rm -rf $(shell ./bin/crystal env CRYSTAL_CACHE_DIR)

.PHONY: help
help: ## Show this help
	@echo
	@printf '\033[34mtargets:\033[0m\n'
	@grep -hE '^[a-zA-Z_-]+:.*?## .*$$' $(MAKEFILE_LIST) |\
		sort |\
		awk 'BEGIN {FS = ":.*?## "}; {printf "  \033[36m%-15s\033[0m %s\n", $$1, $$2}'
	@echo
	@printf '\033[34moptional variables:\033[0m\n'
	@grep -hE '^[a-zA-Z_-]+ \?=.*?## .*$$' $(MAKEFILE_LIST) |\
		sort |\
		awk 'BEGIN {FS = " \\?=.*?## "}; {printf "  \033[36m%-15s\033[0m %s\n", $$1, $$2}'
	@echo
	@printf '\033[34mrecipes:\033[0m\n'
	@grep -hE '^##.*$$' $(MAKEFILE_LIST) |\
		awk 'BEGIN {FS = "## "}; /^## [a-zA-Z_-]/ {printf "  \033[36m%s\033[0m\n", $$2}; /^##  / {printf "  %s\n", $$2}'

=== debian/changelog ===
crystal (1.9.2+dfsg-3) unstable; urgency=medium

  * Disable interpreter again.

 -- David Suárez <deiv@debian.org>  Tue, 08 Aug 2023 20:26:59 +0200

crystal (1.9.2+dfsg-2) unstable; urgency=medium

  * Recover 1.6.0+dfsg-3 version lost changes (Closes: #1043235).
  * Build interpreter again.

 -- David Suárez <deiv@debian.org>  Tue, 08 Aug 2023 16:24:42 +0200

crystal (1.9.2+dfsg-1) unstable; urgency=medium

  * New upstream version (Closes: #1026873).
  * d/patches:
    - Remove patch 'fix-sbuild-pkgbuilddir-filtering-in-unix-spec'.
    - Refresh patch 'remove-check-in-random-failing-test'.
  * Switch to pcre2 (Closes: #1000025).
  * Install fish completion file.
  * debian/control:
    - Bump debhelper compat version.
    - Update standards version; No changes needed.

 -- David Suárez <deiv@debian.org>  Wed, 26 Jul 2023 21:12:38 +0200

=== debian/control ===
Source: crystal
Section: devel
Priority: optional
Maintainer: David Suárez <deiv@debian.org>
Build-Depends: debhelper-compat (= 13),
               git,
               libbsd-dev,
               libedit-dev,
               libevent-dev,
               libgc-dev (>= 1:7.6.0),
               libgmp-dev,
               libpcre2-dev,
               libssl-dev,
               libtool,
               libxml2-dev,
               libyaml-dev,
               libz-dev,
               lld-14,
               llvm-14-dev,
               pkg-config,
               crystal (>= 1.6.0)
Standards-Version: 4.6.2
Homepage: https://crystal-lang.org/
Vcs-Git: https://salsa.debian.org/deiv/crystal.git
Vcs-Browser: https://salsa.debian.org/deiv/crystal
Rules-Requires-Root: no

Package: crystal
Architecture: amd64
Depends: ${misc:Depends},
         ${shlibs:Depends},
         gcc,
         libgc-dev,
         pkg-config,
         libpcre2-dev,
         libevent-dev
Recommends: libssl-dev, libz-dev, libxml2-dev, libgmp-dev, libyaml-dev
Suggests: crystal-doc, crystal-samples
Description: compiler of the Crystal object-oriented programming language
 The Crystal's language syntax is inspired by Ruby, the language is statically
 type-checked but does not require that the type of variables or method
 arguments be specified.
 .
 The language has the following goals: (1) have the same syntax as Ruby, or at
 least as similar as possible; (2) statically type-checked but without having
 to specify the type of variables or method arguments; (3) be able to call C
 code by writing bindings to it in Crystal; (4) have compile-time evaluation
 and generation of code, to avoid boilerplate code; (5) compile to efficient
 native code.

Package: crystal-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Suggests: www-browser
Description: API documentation for the Crystal object-oriented programming language
 The Crystal's language syntax is inspired by Ruby, the language is statically
 type-checked but does not require that the type of variables or method
 arguments be specified.
 .
 This package contains the documentation for the standard library.

Package: crystal-samples
Architecture: all
Depends: ${misc:Depends}
Description: samples for the Crystal object-oriented programming language
 The Crystal's language syntax is inspired by Ruby, the language is statically
 type-checked but does not require that the type of variables or method
 arguments be specified.
 .
 This package contains some examples for starting to play with the language.

## crystal 1.11.2%2Bdfsg

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

include /usr/share/dpkg/architecture.mk

N_CPUS=$(shell grep -c "^processor" /proc/cpuinfo 2>/dev/null)

make_options += release=1
make_options += verbose=1
make_options += progress=1
make_options += threads=$(N_CPUS)
make_options += CRYSTAL_CONFIG_PATH="lib:/usr/lib/crystal/lib"
make_options += CRYSTAL_CACHE_DIR="/tmp/crystal"
make_options += interpreter=1

%:
	dh $@

override_dh_auto_build:
	dh_auto_build -- $(make_options)

override_dh_auto_install: DESTDIR=$(CURDIR)/debian/tmp
override_dh_auto_install:
	dh_auto_install -- PREFIX=/usr

	#
	# clean lib dir, but without deleting (needed by extensions loading):
	#   - ext/libcrystal.a
	#   - llvm/ext/{find-llvm-config, llvm_ext.o)
	#
	find "$(DESTDIR)/usr/share/crystal/src" \
		-iname "sigfault.o" -or \
		-iname "*.c" -or \
		-iname "*.cc" \
		| xargs rm
		
	make install_docs DATADIR=$(DESTDIR)/usr/share/doc/crystal
	
	# fix privacy-breach-generic links on html docs
	sed -i  '/<p><a href=/{:a;N;/alt="Crystal - Born and raised at Manas" \/><\/a><\/p>/!ba};//d' \
		$(DESTDIR)/usr/share/doc/crystal/docs/index.html
		
	# remove vcs file in examples
	rm -f $(DESTDIR)/usr/share/doc/crystal/examples/.gitignore

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	make $(make_options) compiler_spec
	make $(make_options) std_spec
	make $(make_options) primitives_spec
endif

override_dh_clean:
	dh_clean
	rm -f man/*.gz

## crystal 1.11.2+dfsg

=== Makefile ===
--- 
+++ 
@@ -18,6 +18,8 @@
 ##   $ make std_spec
 ## Run compiler tests
 ##   $ make compiler_spec
+## Run generators (Unicode, SSL config, ...)
+##   $ make -B generate_data
 
 CRYSTAL ?= crystal ## which previous crystal compiler use
 LLVM_CONFIG ?=     ## llvm-config command path to use
@@ -125,6 +127,7 @@
 docs: ## Generate standard library documentation
 	$(call check_llvm_config)
 	./bin/crystal docs src/docs_main.cr $(DOCS_OPTIONS) --project-name=Crystal --project-version=$(CRYSTAL_VERSION) --source-refname=$(CRYSTAL_CONFIG_BUILD_COMMIT)
+	cp -av doc/ docs/
 
 .PHONY: crystal
 crystal: $(O)/crystal ## Build the compiler
@@ -136,6 +139,10 @@
 .PHONY: format
 format: ## Format sources
 	./bin/crystal tool format$(if $(check), --check) src spec samples scripts
+
+.PHONY: generate_data
+generate_data: ## Run generator scripts for Unicode, SSL config, ...
+	$(MAKE) -B -f scripts/generate_data.mk
 
 .PHONY: install
 install: $(O)/crystal man/crystal.1.gz ## Install the compiler at DESTDIR
@@ -176,7 +183,6 @@
 
 	cp -av docs "$(DATADIR)/docs"
 	cp -av samples "$(DATADIR)/examples"
-	rm -rf "$(DATADIR)/examples/.gitignore"
 
 .PHONY: uninstall_docs
 uninstall_docs: ## Uninstall docs from DESTDIR
@@ -224,6 +230,7 @@
 .PHONY: clean
 clean: clean_crystal ## Clean up built directories and files
 	rm -rf $(LLVM_EXT_OBJ)
+	rm -rf man/*.gz
 
 .PHONY: clean_crystal
 clean_crystal: ## Clean up crystal built files

=== debian/changelog ===
crystal (1.11.2+dfsg-1build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:40:41 +1100

crystal (1.11.2+dfsg-1build2) noble; urgency=medium

  * No-change rebuild against libevent-2.1-7t64

 -- Simon Chopin <schopin@ubuntu.com>  Fri, 29 Mar 2024 17:20:17 +0100

crystal (1.11.2+dfsg-1build1) noble; urgency=medium

  * No-change rebuild against libllvm17t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 12 Mar 2024 07:08:36 +0000

crystal (1.11.2+dfsg-1) unstable; urgency=medium

  * New upstream version.
  * Build with LLVM 17 (Closes: #1061211).
  * Rename pkg-config to pkgconf.
  * Refresh disable-udp-multicast-specs patch.
  * Reintroduce playground again.
  * Update copyright.
  * Lintian overrides for false positives.

 -- David Suárez <deiv@debian.org>  Thu, 29 Feb 2024 20:11:24 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: crystal
 Section: devel
 Priority: optional
-Maintainer: David Suárez <deiv@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: David Suárez <deiv@debian.org>
 Build-Depends: debhelper-compat (= 13),
                git,
                libbsd-dev,
@@ -15,9 +16,9 @@
                libxml2-dev,
                libyaml-dev,
                libz-dev,
-               lld-14,
-               llvm-14-dev,
-               pkg-config,
+               lld-17,
+               llvm-17-dev,
+               pkgconf,
                crystal (>= 1.6.0)
 Standards-Version: 4.6.2
 Homepage: https://crystal-lang.org/
@@ -31,9 +32,11 @@
          ${shlibs:Depends},
          gcc,
          libgc-dev,
-         pkg-config,
+         pkgconf,
          libpcre2-dev,
-         libevent-dev
+         libevent-dev,
+         libjs-codemirror,
+         libjs-jquery
 Recommends: libssl-dev, libz-dev, libxml2-dev, libgmp-dev, libyaml-dev
 Suggests: crystal-doc, crystal-samples
 Description: compiler of the Crystal object-oriented programming language

## crystal 1.12.1+dfsg

=== Makefile ===
--- 
+++ 
@@ -59,10 +59,9 @@
 	CRYSTAL_CONFIG_LIBRARY_PATH=$(CRYSTAL_CONFIG_LIBRARY_PATH)
 SHELL = sh
 LLVM_CONFIG := $(shell src/llvm/ext/find-llvm-config)
-LLVM_VERSION := $(if $(LLVM_CONFIG), $(shell $(LLVM_CONFIG) --version 2> /dev/null))
+LLVM_VERSION := $(if $(LLVM_CONFIG),$(shell $(LLVM_CONFIG) --version 2> /dev/null))
 LLVM_EXT_DIR = src/llvm/ext
 LLVM_EXT_OBJ = $(LLVM_EXT_DIR)/llvm_ext.o
-DEPS = $(LLVM_EXT_OBJ)
 CXXFLAGS += $(if $(debug),-g -O0)
 CRYSTAL_VERSION ?= $(shell cat src/VERSION)
 
@@ -80,6 +79,13 @@
   colorize = $(shell printf >&2 "\033[33m$1\033[0m\n")
 endif
 
+DEPS = $(LLVM_EXT_OBJ)
+ifneq ($(LLVM_VERSION),)
+  ifeq ($(shell test $(firstword $(subst ., ,$(LLVM_VERSION))) -ge 18; echo $$?),0)
+    DEPS =
+  endif
+endif
+
 check_llvm_config = $(eval \
 	check_llvm_config := $(if $(LLVM_VERSION),\
 	  $(call colorize,Using $(LLVM_CONFIG) [version=$(LLVM_VERSION)]),\
@@ -208,7 +214,7 @@
 	@mkdir -p $(O)
 	$(EXPORT_CC) ./bin/crystal build $(FLAGS) $(SPEC_WARNINGS_OFF) -o $@ spec/primitives_spec.cr
 
-$(O)/interpreter_spec: deps $(SOURCES) $(SPEC_SOURCES)
+$(O)/interpreter_spec: $(DEPS) $(SOURCES) $(SPEC_SOURCES)
 	$(eval interpreter=1)
 	@mkdir -p $(O)
 	$(EXPORT_CC) ./bin/crystal build $(FLAGS) $(SPEC_WARNINGS_OFF) -o $@ spec/compiler/interpreter_spec.cr

=== debian/changelog ===
crystal (1.12.1+dfsg-1) unstable; urgency=medium

  * New upstream version (Closes: #1070456).
  * Refresh disable-udp-multicast-specs patch.

 -- David Suárez <deiv@debian.org>  Fri, 17 May 2024 20:30:19 +0200

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: crystal
 Section: devel
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: David Suárez <deiv@debian.org>
+Maintainer: David Suárez <deiv@debian.org>
 Build-Depends: debhelper-compat (= 13),
                git,
                libbsd-dev,

## crystal 1.14.0+dfsg

=== Makefile ===
--- 
+++ 
@@ -46,7 +46,8 @@
 CRYSTAL_CONFIG_LIBRARY_PATH := '$$ORIGIN/../lib/crystal'
 CRYSTAL_CONFIG_BUILD_COMMIT ?= $(shell git rev-parse --short HEAD 2> /dev/null)
 CRYSTAL_CONFIG_PATH := '$$ORIGIN/../share/crystal/src'
-SOURCE_DATE_EPOCH ?= $(shell (git show -s --format=%ct HEAD || stat -c "%Y" Makefile || stat -f "%m" Makefile) 2> /dev/null)
+CRYSTAL_VERSION ?= $(shell cat src/VERSION)
+SOURCE_DATE_EPOCH ?= $(shell (cat src/SOURCE_DATE_EPOCH || (git show -s --format=%ct HEAD || stat -c "%Y" Makefile || stat -f "%m" Makefile)) 2> /dev/null)
 ifeq ($(shell command -v ld.lld >/dev/null && uname -s),Linux)
   EXPORT_CC ?= CC="$(CC) -fuse-ld=lld"
 endif
@@ -63,7 +64,6 @@
 LLVM_EXT_DIR = src/llvm/ext
 LLVM_EXT_OBJ = $(LLVM_EXT_DIR)/llvm_ext.o
 CXXFLAGS += $(if $(debug),-g -O0)
-CRYSTAL_VERSION ?= $(shell cat src/VERSION)
 
 DESTDIR ?=
 PREFIX ?= /usr/local

=== debian/changelog ===
crystal (1.14.0+dfsg-1build2) questing; urgency=medium

  * No-change rebuild for libxml2 soname change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 26 May 2025 14:22:51 +0200

crystal (1.14.0+dfsg-1build1) questing; urgency=medium

  * No-change rebuild for libxml2 soname change.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 21 May 2025 08:15:41 +0200

crystal (1.14.0+dfsg-1) unstable; urgency=medium

  * New upstream version (Closes: #1082568).
  * Build with LLVM 19 (Closes: #1084068).
  * Update standards version; no changes needed.

 -- David Suárez <deiv@debian.org>  Fri, 20 Dec 2024 17:35:09 +0100

=== debian/control ===
--- 
+++ 
@@ -15,11 +15,11 @@
                libxml2-dev,
                libyaml-dev,
                libz-dev,
-               lld-17,
-               llvm-17-dev,
+               lld-19,
+               llvm-19-dev,
                pkgconf,
                crystal (>= 1.6.0)
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Homepage: https://crystal-lang.org/
 Vcs-Git: https://salsa.debian.org/deiv/crystal.git
 Vcs-Browser: https://salsa.debian.org/deiv/crystal

## crystal 1.18.2+dfsg

=== debian/changelog ===
crystal (1.18.2+dfsg-1) unstable; urgency=medium

  * New upstream version (Closes: #1107235).
  * Update standards version; no changes needed.
  * Refresh disable-udp-multicast-specs patch.
  * Update copyright.
  * d/rules:
    - Doc install rule nows honor PREFIX, use it.
    - Clean generated docs.

 -- David Suárez <deiv@debian.org>  Tue, 25 Nov 2025 17:19:53 +0100

=== debian/control ===
--- 
+++ 
@@ -19,7 +19,7 @@
                llvm-19-dev,
                pkgconf,
                crystal (>= 1.6.0)
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: https://crystal-lang.org/
 Vcs-Git: https://salsa.debian.org/deiv/crystal.git
 Vcs-Browser: https://salsa.debian.org/deiv/crystal

=== debian/rules ===
--- 
+++ 
@@ -36,7 +36,7 @@
 		-iname "*.cc" \
 		| xargs rm
 		
-	make install_docs DATADIR=$(DESTDIR)/usr/share/doc/crystal
+	make install_docs PREFIX=/usr DESTDIR=$(DESTDIR)
 	
 	# fix privacy-breach-generic links on html docs
 	sed -i  '/<p><a href=/{:a;N;/alt="Crystal - Born and raised at Manas" \/><\/a><\/p>/!ba};//d' \
@@ -55,3 +55,4 @@
 override_dh_clean:
 	dh_clean
 	rm -f man/*.gz
+	rm -Rf docs

## crystal toolkit-2022.11.17

=== tests/asy_test/single/Makefile ===
all: interact

interact:
	asy  -V GaN.asy

offscreen:
	asy --offscreen GaN.asy

## crystal toolkit-2023.1.28.dev0

=== docs_rst/Makefile ===
# Minimal makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
SOURCEDIR     = .
BUILDDIR      = _build

# Put it first so that "make" without argument is like "make help".
help:
	@$(SPHINXBUILD) -M help "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

.PHONY: help Makefile

# Catch-all target: route all unknown targets to Sphinx using the new
# "make mode" option.  $(O) is meant as a shortcut for $(SPHINXOPTS).
%: Makefile
	@rm -rf ../docs/
	@rm -rf source/
	@sphinx-apidoc -e -f -o source/ ../crystal_toolkit ../crystal_toolkit/apps
	@$(SPHINXBUILD) -M $@ "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)
	@cp -r "$(BUILDDIR)/html/." ../docs/
	@cp CNAME ../docs/

=== tests/requirements.txt ===
# Packages needed to run the tests.
# Switch into a virtual environment
# pip install -r requirements.txt

chromedriver-binary
dash[testing]>=0.31.0  # be sure to install dash with additional dependencies for testing
dash-core-components
dash-html-components
dash-renderer
ipdb
percy
selenium==4.2 # pin needed due to DashComposite AttributeError: 'WebDriver' object has no attribute 'find_element_by_css_selector' (see https://stackoverflow.com/a/72754667)
flake8
pylint

=== tests/asy_test/multi/Makefile ===
SRCS = $(wildcard *.asy)
PROGS = $(patsubst %.asy,%,$(SRCS))
all: $(PROGS)
%: %.asy
	asy -render 5 -f png $<

=== tests/asy_test/single/Makefile ===
all: interact

interact:
	asy -V GaN.asy

offscreen:
	asy --offscreen GaN.asy
